import { performance} from'perf_hooks'
const {now} = performance

import {
  createWorld,
  registerComponent,
  registerComponents,
  defineComponent,
  defineQuery,
  Changed,
  Not,
  enterQuery,
  exitQuery,
  defineSystem,
  addComponent,
  removeComponent,
  addEntity,
  removeEntity,
  defineSerializer,
  defineDeserializer,
  commitRemovals,
  Types,
} from './src/index.js'

const world = createWorld()

const { f32 } = Types
const Vector2 = { x: f32, y: f32 }
const Position = defineComponent(Vector2)
const Velocity = defineComponent(Vector2)
// registerComponents(world, [Position, Velocity])

const query = defineQuery([Position,Velocity])
// const serialize = defineSerializer([Changed(Position)])
// const deserialize = defineDeserializer([Position,Velocity])

// const notPosition = defineQuery([Not(Position)])

const move = defineSystem(world => {
  const ents = query(world)
  for (let i = 0; i < ents.length; i++) {
    const eid = ents[i]
    Position.x[eid] += Velocity.x[eid]
    Position.y[eid] += Velocity.y[eid]
  }
})

const n = 500_000
for (let i = 0; i < n; i++) {
  const eid = addEntity(world)
  addComponent(world, Position, eid)
  addComponent(world, Velocity, eid)
  Velocity.x[eid]++
  Velocity.y[eid]++
}

let then

for (let i = 0; i < 50; i++) {
  then = now()
  move(world)
  console.log(now()-then)
}

console.log(Position.x[0])



